return function(logTag, enable)
    local M = {}

    local dd = obj.debugDrawProxy
    local textCol = color(255, 60, 255, 255)

    function dText(row, text)
        if not enable then
            return
        end

        dd:drawText2D(float3(20, 20 + (15 * row), 0), textCol, text)
    end

    function _log(level, text)
        if not enable then
            return
        end

        if not text then -- Shift arguments
            text = level
            level = "D"
        end

        log(level, logTag, text)
    end

    M.dText = dText
    M.log = _log

    return M
end